#line 1 "C:/Users/Public/Documents/Mikroelektronika/Visual GLCD/Projects/AdrianSeeder_Code/mikroC PRO for PIC/AdrianSeeder_driver.c"
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_objects.h"
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
#line 165 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
void T6963C_init(unsigned int w, unsigned char h, unsigned char fntW);
void T6963C_writeData(unsigned char mydata);
void T6963C_writeCommand(unsigned char mydata);
void T6963C_setPtr(unsigned int addr, unsigned char t);
void T6963C_waitReady(void);
void T6963C_fill(unsigned char mydata, unsigned int start, unsigned int len);
void T6963C_dot(int x, int y, unsigned char color);
void T6963C_write_char(unsigned char c, unsigned char x, unsigned char y, unsigned char mode);
void T6963C_write_text(unsigned char *str, unsigned char x, unsigned char y, unsigned char mode);
void T6963C_line(int px0, int py0, int px1, int py1, unsigned char pcolor);
void T6963C_rectangle(int x0, int y0, int x1, int y1, unsigned char pcolor);
void T6963C_box(int x0, int y0, int x1, int y1, unsigned char pcolor);
void T6963C_circle(int x, int y, long r, unsigned char pcolor);
void T6963C_image(const char *pic);
void T6963C_sprite(unsigned char px, unsigned char py, const char *pic, unsigned char sx, unsigned char sy);
void T6963C_set_cursor(unsigned char x, unsigned char y);
void T6963C_PartialImage(unsigned int x_left, unsigned int y_top, unsigned int width,
 unsigned int height, code const unsigned short * image);
void T6963C_Rectangle_Round_Edges(unsigned int x_upper_left, unsigned int y_upper_left,
 unsigned int x_bottom_right, unsigned int y_bottom_right,
 unsigned int round_radius, unsigned short color);
void T6963C_Rectangle_Round_Edges_Fill(unsigned int x_upper_left, unsigned int y_upper_left,
 unsigned int x_bottom_right, unsigned int y_bottom_right,
 unsigned int round_radius, unsigned short color);
void T6963C_Circle_Fill(int x_center, int y_center, int radius, unsigned short color);
#line 194 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
extern sfr char T6963C_dataPort;
extern sfr char T6963C_cntlPort;

extern unsigned int T6963C_grWidth;
extern unsigned int T6963C_grHeight;
extern unsigned int T6963C_txtCols;

extern unsigned int T6963C_fontWidth;
extern unsigned int T6963C_grHomeAddr;
extern unsigned int T6963C_textHomeAddr;
extern unsigned int T6963C_grMemSize;
extern unsigned int T6963C_txtMemSize;

extern sfr sbit T6963C_cntlwr;
extern sfr sbit T6963C_cntlrd;
extern sfr sbit T6963C_cntlcd;
extern sfr sbit T6963C_cntlrst;

extern unsigned char T6963C_display;
#line 2 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char Visible;
 char Active;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 char Corner_Radius;
 char PressColEnabled;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char *Caption;
 const char *FontName;
 unsigned char Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef const struct CLabel {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 const char *Caption;
 const char *FontName;
 unsigned char Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef const struct CBox_Round {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char Visible;
 char Active;
 char Transparent;
 char Corner_Radius;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCBox_Round;

struct Screen {
 unsigned short ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int CBoxes_RoundCount;
 TCBox_Round * const code *CBoxes_Round;
};

extern TScreen Screen1;
extern TCBox_Round BoxRound1;
extern TCBox_Round BoxRound2;
extern TCLabel Label1;
extern TCLabel Label2;
extern TButton_Round PauseButton;
extern TButton_Round ResetCounterButton;
extern TCLabel Label6;
extern TCLabel Label7;
extern TCLabel Label8;
extern TCLabel Label9;
extern TCLabel Label10;
extern TCLabel Label3;
extern TLabel Km_Box_Text;
extern TLabel acres_box_text;
extern TLabel hectares_box_text;
extern TButton_Round Resume_Button;
extern TButton_Round * const code Screen1_Buttons_Round[3];
extern TLabel * const code Screen1_Labels[3];
extern TCLabel * const code Screen1_CLabels[8];
extern TCBox_Round * const code Screen1_CBoxes_Round[2];





void PauseButtonOnPress();
void ResetCounterButtonOnPress();
void ResumeButtonOnPress();




extern const char BoxRound1_Caption[];
extern const char BoxRound2_Caption[];
extern const char Label1_Caption[];
extern const char Label2_Caption[];
extern char PauseButton_Caption[];
extern char ResetCounterButton_Caption[];
extern const char Label6_Caption[];
extern const char Label7_Caption[];
extern const char Label8_Caption[];
extern const char Label9_Caption[];
extern const char Label10_Caption[];
extern const char Label3_Caption[];
extern char Km_Box_Text_Caption[];
extern char acres_box_text_Caption[];
extern char hectares_box_text_Caption[];
extern char Resume_Button_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawCRoundBox(TCBox_Round *ACround_box);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_resources.h"
const code char Tahoma16x19_Regular[];
const code char Tahoma19x23_Regular[];
const code char Tahoma10x11_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 7 "C:/Users/Public/Documents/Mikroelektronika/Visual GLCD/Projects/AdrianSeeder_Code/mikroC PRO for PIC/AdrianSeeder_driver.c"
char T6963C_dataPort at PORTH;
sbit T6963C_ctrlwr at RJ2_bit;
sbit T6963C_ctrlrd at RJ1_bit;
sbit T6963C_ctrlcd at RJ0_bit;
sbit T6963C_ctrlrst at RJ4_bit;
sbit T6963C_ctrlce at RJ3_bit;
sbit T6963C_ctrlfs at RJ6_bit;
sbit T6963C_ctrlmd at RJ5_bit;
sbit T6963C_ctrlwr_Direction at TRISJ2_bit;
sbit T6963C_ctrlrd_Direction at TRISJ1_bit;
sbit T6963C_ctrlcd_Direction at TRISJ0_bit;
sbit T6963C_ctrlrst_Direction at TRISJ4_bit;
sbit T6963C_ctrlce_Direction at TRISJ3_bit;
sbit T6963C_ctrlfs_Direction at TRISJ6_bit;
sbit T6963C_ctrlmd_Direction at TRISJ5_bit;

sbit BacklightRed_Direction at TRISC2_bit;
sbit BacklightGreen_Direction at TRISC1_bit;
sbit BacklightBlue_Direction at TRISG0_bit;
sbit BacklightRed at RC2_bit;
sbit BacklightGreen at RC1_bit;
sbit BacklightBlue at RG0_bit;



sbit DriveA at LATG3_bit;
sbit DriveB at LATG4_bit;
sbit DriveA_Direction at TRISG3_bit;
sbit DriveB_Direction at TRISG4_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
typedef unsigned long TPointer;
TPointer PressedObject;
int PressedObjectType;
unsigned int T6963C_caption_length, T6963C_caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCLabel *local_clabel;
TCLabel *exec_clabel;
int clabel_order;
TCBox_Round *local_round_cbox;
TCBox_Round *exec_round_cbox;
int cbox_round_order;



void Init_ADC() {
 ADCON1 = 0x0D;
 ADC_Init();
}
static void InitializeTouchPanel() {
 Init_ADC();
 T6963C_ctrlce_Direction = 0;
 T6963C_ctrlce = 0;
 T6963C_ctrlmd_Direction = 0;
 T6963C_ctrlmd = 0;
 T6963C_ctrlfs_Direction = 0;
 T6963C_ctrlfs = 0;

 BacklightRed_Direction = 0;
 BacklightGreen_Direction = 0;
 BacklightBlue_Direction = 0;
 BacklightRed = 0;
 BacklightGreen = 0;
 BacklightBlue = 0;


 T6963C_init(240, 128, 8);
  T6963C_display. F3  = 1; T6963C_writeCommand(T6963C_display) ;
  T6963C_display. F2  = 1; T6963C_writeCommand(T6963C_display) ;
  T6963C_display. F1  = 0; T6963C_writeCommand(T6963C_display) ;

 TP_Init(240, 128, 0, 1);
 TP_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TCBox_Round BoxRound1 =
 {
 &Screen1 ,
 0 ,
 87 ,
 6 ,
 50 ,
 22 ,
 1 ,
 1 ,
 1 ,
 3 ,
 0 ,
 0 ,
 0 ,
 0
 };
 TCBox_Round BoxRound2 =
 {
 &Screen1 ,
 1 ,
 180 ,
 6 ,
 51 ,
 22 ,
 1 ,
 1 ,
 1 ,
 3 ,
 0 ,
 0 ,
 0 ,
 0
 };
 TCLabel Label1 =
 {
 &Screen1 ,
 2 ,
 182 ,
 4 ,
 43 ,
 25 ,
 &Label1_Caption ,
 &Tahoma19x23_Regular ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label1_Caption[5] = "2500";

 TCLabel Label2 =
 {
 &Screen1 ,
 3 ,
 91 ,
 4 ,
 43 ,
 25 ,
 &Label2_Caption ,
 &Tahoma19x23_Regular ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label2_Caption[5] = "2260";

 TButton_Round PauseButton;
char PauseButton_Caption[6] = "Pause";

 TButton_Round ResetCounterButton;
char ResetCounterButton_Caption[14] = "Reset Counter";

 TCLabel Label6 =
 {
 &Screen1 ,
 6 ,
 142 ,
 15 ,
 24 ,
 12 ,
 &Label6_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label6_Caption[6] = "Width";

 TCLabel Label7 =
 {
 &Screen1 ,
 7 ,
 1 ,
 10 ,
 80 ,
 12 ,
 &Label7_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label7_Caption[19] = "Tyre Circumference";

 TCLabel Label8 =
 {
 &Screen1 ,
 8 ,
 6 ,
 40 ,
 50 ,
 12 ,
 &Label8_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label8_Caption[11] = "Km Covered";

 TCLabel Label9 =
 {
 &Screen1 ,
 9 ,
 6 ,
 60 ,
 46 ,
 12 ,
 &Label9_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label9_Caption[11] = "Ac Covered";

 TCLabel Label10 =
 {
 &Screen1 ,
 10 ,
 6 ,
 80 ,
 47 ,
 12 ,
 &Label10_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label10_Caption[11] = "Ha Covered";

 TCLabel Label3 =
 {
 &Screen1 ,
 11 ,
 142 ,
 3 ,
 34 ,
 12 ,
 &Label3_Caption ,
 &T6963C_defaultFont ,
  0b1000  ,
 1 ,
 1 ,
 0 ,
 0 ,
 0 ,
 0
 };
const char Label3_Caption[8] = "Machine";

 TLabel Km_Box_Text;
char Km_Box_Text_Caption[31] = "0";

 TLabel Acres_box_text;
char acres_box_text_Caption[31] = "0";

 TLabel Hectares_box_text;
char hectares_box_text_Caption[31] = "0";

 TButton_Round Resume_Button;
char Resume_Button_Caption[7] = "Resume";

 TButton_Round * const code Screen1_Buttons_Round[3]=
 {
 &PauseButton,
 &ResetCounterButton,
 &Resume_Button
 };
 TLabel * const code Screen1_Labels[3]=
 {
 &Km_Box_Text,
 &Acres_box_text,
 &Hectares_box_text
 };
 TCLabel * const code Screen1_CLabels[8]=
 {
 &Label1,
 &Label2,
 &Label6,
 &Label7,
 &Label8,
 &Label9,
 &Label10,
 &Label3
 };
 TCBox_Round * const code Screen1_CBoxes_Round[2]=
 {
 &BoxRound1,
 &BoxRound2
 };




static void InitializeObjects() {
 Screen1.Buttons_RoundCount = 3;
 Screen1.Buttons_Round = Screen1_Buttons_Round;
 Screen1.LabelsCount = 3;
 Screen1.Labels = Screen1_Labels;
 Screen1.CLabelsCount = 8;
 Screen1.CLabels = Screen1_CLabels;
 Screen1.CBoxes_RoundCount = 2;
 Screen1.CBoxes_Round = Screen1_CBoxes_Round;
 Screen1.ObjectsCount = 16;


 PauseButton.OwnerScreen = &Screen1;
 PauseButton.Order = 4;
 PauseButton.Left = 90;
 PauseButton.Top = 99;
 PauseButton.Width = 69;
 PauseButton.Height = 23;
 PauseButton.Visible = 1;
 PauseButton.Active = 1;
 PauseButton.Caption = PauseButton_Caption;
 PauseButton.TextAlign = _taCenter;
 PauseButton.FontName = T6963C_defaultFont;
 PauseButton.PressColEnabled = 1;
 PauseButton.Corner_Radius = 3;
 PauseButton.OnUpPtr = 0;
 PauseButton.OnDownPtr = 0;
 PauseButton.OnClickPtr = 0;
 PauseButton.OnPressPtr = PauseButtonOnPress;

 ResetCounterButton.OwnerScreen = &Screen1;
 ResetCounterButton.Order = 5;
 ResetCounterButton.Left = 7;
 ResetCounterButton.Top = 99;
 ResetCounterButton.Width = 77;
 ResetCounterButton.Height = 23;
 ResetCounterButton.Visible = 1;
 ResetCounterButton.Active = 1;
 ResetCounterButton.Caption = ResetCounterButton_Caption;
 ResetCounterButton.TextAlign = _taCenter;
 ResetCounterButton.FontName = T6963C_defaultFont;
 ResetCounterButton.PressColEnabled = 1;
 ResetCounterButton.Corner_Radius = 3;
 ResetCounterButton.OnUpPtr = 0;
 ResetCounterButton.OnDownPtr = 0;
 ResetCounterButton.OnClickPtr = 0;
 ResetCounterButton.OnPressPtr = ResetCounterButtonOnPress;

 Km_Box_Text.OwnerScreen = &Screen1;
 Km_Box_Text.Order = 12;
 Km_Box_Text.Left = 85;
 Km_Box_Text.Top = 32;
 Km_Box_Text.Width = 9;
 Km_Box_Text.Height = 21;
 Km_Box_Text.Visible = 1;
 Km_Box_Text.Active = 1;
 Km_Box_Text.Caption = Km_Box_Text_Caption;
 Km_Box_Text.FontName = Tahoma16x19_Regular;
 Km_Box_Text.Font_Color =  0b1000 ;
 Km_Box_Text.OnUpPtr = 0;
 Km_Box_Text.OnDownPtr = 0;
 Km_Box_Text.OnClickPtr = 0;
 Km_Box_Text.OnPressPtr = 0;

 acres_box_text.OwnerScreen = &Screen1;
 acres_box_text.Order = 13;
 acres_box_text.Left = 85;
 acres_box_text.Top = 54;
 acres_box_text.Width = 9;
 acres_box_text.Height = 21;
 acres_box_text.Visible = 1;
 acres_box_text.Active = 1;
 acres_box_text.Caption = Acres_box_text_Caption;
 acres_box_text.FontName = Tahoma16x19_Regular;
 acres_box_text.Font_Color =  0b1000 ;
 acres_box_text.OnUpPtr = 0;
 acres_box_text.OnDownPtr = 0;
 acres_box_text.OnClickPtr = 0;
 acres_box_text.OnPressPtr = 0;

 hectares_box_text.OwnerScreen = &Screen1;
 hectares_box_text.Order = 14;
 hectares_box_text.Left = 85;
 hectares_box_text.Top = 75;
 hectares_box_text.Width = 9;
 hectares_box_text.Height = 21;
 hectares_box_text.Visible = 1;
 hectares_box_text.Active = 1;
 hectares_box_text.Caption = Hectares_box_text_Caption;
 hectares_box_text.FontName = Tahoma16x19_Regular;
 hectares_box_text.Font_Color =  0b1000 ;
 hectares_box_text.OnUpPtr = 0;
 hectares_box_text.OnDownPtr = 0;
 hectares_box_text.OnClickPtr = 0;
 hectares_box_text.OnPressPtr = 0;

 Resume_Button.OwnerScreen = &Screen1;
 Resume_Button.Order = 15;
 Resume_Button.Left = 164;
 Resume_Button.Top = 99;
 Resume_Button.Width = 69;
 Resume_Button.Height = 23;
 Resume_Button.Visible = 1;
 Resume_Button.Active = 1;
 Resume_Button.Caption = Resume_Button_Caption;
 Resume_Button.TextAlign = _taCenter;
 Resume_Button.FontName = T6963C_defaultFont;
 Resume_Button.PressColEnabled = 1;
 Resume_Button.Corner_Radius = 3;
 Resume_Button.OnUpPtr = 0;
 Resume_Button.OnDownPtr = 0;
 Resume_Button.OnClickPtr = 0;
 Resume_Button.OnPressPtr = ResumeButtonOnPress;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}








void DrawRoundButton(TButton_Round *Around_button) {

 if (Around_button->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 T6963C_Rectangle_Round_Edges(Around_button->Left - 1, Around_button->Top - 1,
 Around_button->Left + Around_button->Width,
 Around_button->Top + Around_button->Height, Around_button->Corner_Radius,  0b1000 );
 T6963C_Rectangle_Round_Edges(Around_button->Left, Around_button->Top,
 Around_button->Left + Around_button->Width - 1,
 Around_button->Top + Around_button->Height - 1, Around_button->Corner_Radius,  0 );
 T6963C_Rectangle_Round_Edges_Fill(Around_button->Left + 1, Around_button->Top + 1,
 Around_button->Left + Around_button->Width - 2,
 Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius,  0b1000 );
 }
 else {
 T6963C_Rectangle_Round_Edges(Around_button->Left - 1, Around_button->Top - 1,
 Around_button->Left + Around_button->Width,
 Around_button->Top + Around_button->Height, Around_button->Corner_Radius,  0 );
 T6963C_Rectangle_Round_Edges_Fill(Around_button->Left, Around_button->Top,
 Around_button->Left + Around_button->Width - 1,
 Around_button->Top + Around_button->Height - 1, Around_button->Corner_Radius,  0b1000 );
 if ((Around_button->Width >= 5) && (Around_button->Height >= 5)) {
 T6963C_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
 Around_button->Left + Around_button->Width - 2,
 Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius,  0 );
 }
 }
 T6963C_Set_Font_Adv(Around_button->FontName,  0 , _T6963C_HORIZONTAL);
 T6963C_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
 if (Around_button->TextAlign == _taLeft)
 T6963C_Write_Text_Adv(Around_button->Caption, Around_button->Left + 3, (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
 else if (Around_button->TextAlign == _taCenter)
 T6963C_Write_Text_Adv(Around_button->Caption, (Around_button->Left + (Around_button->Width - T6963C_caption_length) / 2), (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
 else if (Around_button->TextAlign == _taRight)
 T6963C_Write_Text_Adv(Around_button->Caption, Around_button->Left + (Around_button->Width - T6963C_caption_length - 4), (Around_button->Top + ((Around_button->Height - T6963C_caption_height) / 2)));
 }
}

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 T6963C_Set_Font_Adv(ALabel->FontName, ALabel->Font_Color, _T6963C_HORIZONTAL);
 T6963C_Write_Text_Adv(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCLabel(TCLabel *ALabel) {
 if (ALabel->Visible == 1) {
 T6963C_Set_Font_Adv(ALabel->FontName, ALabel->Font_Color, _T6963C_HORIZONTAL);
 T6963C_Write_Const_Text_Adv(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCRoundBox(TCBox_Round *Around_box) {
 if (Around_box->Visible == 1) {
 if (Around_box->Transparent == 1) {
 T6963C_Rectangle_Round_Edges(Around_box->Left, Around_box->Top,
 Around_box->Left + Around_box->Width - 1,
 Around_box->Top + Around_box->Height - 1,
 Around_box->Corner_Radius,  0b1000 );
 }
 else {
 T6963C_Rectangle_Round_Edges_Fill(Around_box->Left, Around_box->Top,
 Around_box->Left + Around_box->Width - 1,
 Around_box->Top + Around_box->Height - 1,
 Around_box->Corner_Radius,  0b1000 );
 }
 }
}

void DrawScreen(TScreen *aScreen) {
 int order;
 unsigned short round_button_idx;
 TButton_Round *local_round_button;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short clabel_idx;
 TCLabel *local_clabel;
 unsigned short round_cbox_idx;
 TCBox_Round *local_round_cbox;

 object_pressed = 0;
 order = 0;
 round_button_idx = 0;
 label_idx = 0;
 clabel_idx = 0;
 round_cbox_idx = 0;
 CurrentScreen = aScreen;

  T6963C_fill(0, 0, T6963C_grMemSize) ;
  T6963C_fill(0, T6963C_grMemSize, T6963C_txtMemSize) ;

 while (order < CurrentScreen->ObjectsCount) {
 if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
 local_round_button =  CurrentScreen->Buttons_Round[round_button_idx] ;
 if (order == local_round_button->Order) {
 order++;
 round_button_idx++;
 DrawRoundButton(local_round_button);
 }
 }

 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (clabel_idx < CurrentScreen->CLabelsCount) {
 local_clabel =  CurrentScreen->CLabels[clabel_idx] ;
 if (order == local_clabel->Order) {
 clabel_idx++;
 order++;
 DrawCLabel(local_clabel);
 }
 }

 if (round_cbox_idx < CurrentScreen->CBoxes_RoundCount) {
 local_round_cbox =  CurrentScreen->CBoxes_Round[round_cbox_idx] ;
 if (order == local_round_cbox->Order) {
 round_cbox_idx++;
 order++;
 DrawCRoundBox(local_round_cbox);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 round_button_order = -1;
 label_order = -1;
 clabel_order = -1;
 cbox_round_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
 local_round_button =  CurrentScreen->Buttons_Round[_object_count] ;
 if (local_round_button->Active == 1) {
 if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
 local_round_button->Width, local_round_button->Height) == 1) {
 round_button_order = local_round_button->Order;
 exec_round_button = local_round_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CLabelsCount ; _object_count++ ) {
 local_clabel =  CurrentScreen->CLabels[_object_count] ;
 if (local_clabel->Active == 1) {
 if (IsInsideObject(X, Y, local_clabel->Left, local_clabel->Top,
 local_clabel->Width, local_clabel->Height) == 1) {
 clabel_order = local_clabel->Order;
 exec_clabel = local_clabel;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CBoxes_RoundCount ; _object_count++ ) {
 local_round_cbox =  CurrentScreen->CBoxes_Round[_object_count] ;
 if (local_round_cbox->Active == 1) {
 if (IsInsideObject(X, Y, local_round_cbox->Left, local_round_cbox->Top,
 local_round_cbox->Width, local_round_cbox->Height) == 1) {
 cbox_round_order = local_round_cbox->Order;
 exec_round_cbox = local_round_cbox;
 }
 }
 }

 _object_count = -1;
 if (round_button_order > _object_count)
 _object_count = round_button_order;
 if (label_order > _object_count )
 _object_count = label_order;
 if (clabel_order > _object_count )
 _object_count = clabel_order;
 if (cbox_round_order > _object_count )
 _object_count = cbox_round_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_round_button = 0;
 exec_label = 0;
 exec_clabel = 0;
 exec_round_cbox = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {
 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnPressPtr != 0) {
 exec_round_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == clabel_order) {
 if (exec_clabel->Active == 1) {
 if (exec_clabel->OnPressPtr != 0) {
 exec_clabel->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == cbox_round_order) {
 if (exec_round_cbox->Active == 1) {
 if (exec_round_cbox->OnPressPtr != 0) {
 exec_round_cbox->OnPressPtr();
 return;
 }
 }
 }

 }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 1: {
 if (PressedObject != 0) {
 exec_round_button = (TButton_Round*)PressedObject;
 if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
 DrawRoundButton(exec_round_button);
 }
 break;
 }
 break;
 }

 case 15: {
 if (PressedObject != 0) {
 exec_round_cbox = (TCBox_Round*)PressedObject;
 }
 break;
 }
 }

 exec_label = 0;
 exec_clabel = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnUpPtr != 0)
 exec_round_button->OnUpPtr();
 if (PressedObject == (TPointer)exec_round_button)
 if (exec_round_button->OnClickPtr != 0)
 exec_round_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (TPointer)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == clabel_order) {
 if (exec_clabel->Active == 1) {
 if (exec_clabel->OnUpPtr != 0)
 exec_clabel->OnUpPtr();
 if (PressedObject == (TPointer)exec_clabel)
 if (exec_clabel->OnClickPtr != 0)
 exec_clabel->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == cbox_round_order) {
 if (exec_round_cbox->Active == 1) {
 if (exec_round_cbox->OnUpPtr != 0)
 exec_round_cbox->OnUpPtr();
 if (PressedObject == (TPointer)exec_round_cbox)
 if (exec_round_cbox->OnClickPtr != 0)
 exec_round_cbox->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_round_button = 0;
 exec_label = 0;
 exec_clabel = 0;
 exec_round_cbox = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawRoundButton(exec_round_button);
 }
 PressedObject = (TPointer)exec_round_button;
 PressedObjectType = 1;
 if (exec_round_button->OnDownPtr != 0) {
 exec_round_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (TPointer)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == clabel_order) {
 if (exec_clabel->Active == 1) {
 PressedObject = (TPointer)exec_clabel;
 PressedObjectType = 10;
 if (exec_clabel->OnDownPtr != 0) {
 exec_clabel->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == cbox_round_order) {
 if (exec_round_cbox->Active == 1) {
 PressedObject = (TPointer)exec_round_cbox;
 PressedObjectType = 15;
 if (exec_round_cbox->OnDownPtr != 0) {
 exec_round_cbox->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (TP_Press_Detect()) {

 if (TP_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {

}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();


 TP_Set_Calibration_Consts(48, 947, 88, 898);

 InitializeObjects();
 DrawScreen(&Screen1);
}
