#include "AdrianSeeder_objects.h"
#include "AdrianSeeder_resources.h"

//--------------------- User code ---------------------//
#define FontColor            0x0000
#define BackGroundColor      0xFFFF

extern float acres_covered;
extern float km_traveled ;
extern float hectares_covered;
extern unsigned long current_count;
void update_boxes(void);

extern void calculate_convert(void);

void ClearLabel(TLabel *lbl){
  T6963C_Set_Font_Adv(lbl->Fontname, 0, 0);
  T6963C_Write_Text_Adv(lbl->Caption, lbl->Left, lbl->Top);
}

 /* Update Text Boxes */
 void update_boxes(void){
     calculate_convert();
    
     ClearLabel(&Km_Box_Text);
     sprintf(Km_Box_Text.Caption,"%.3f",km_traveled);
     DrawLabel(&Km_Box_Text);

     ClearLabel(&Acres_Box_Text);
     sprintf(Acres_Box_Text.Caption,"%.3f",acres_covered);
     DrawLabel(&Acres_Box_Text);

     ClearLabel(&Hectares_Box_Text);
     sprintf(Hectares_Box_Text.Caption,"%.3f",hectares_covered);
     DrawLabel(&Hectares_Box_Text);
}

//----------------- End of User code ------------------//

// Event Handlers


void ResetCounterButtonOnPress() {
current_count = 0;
update_boxes();
}

void ResumeButtonOnPress() {
 TMR0ON_bit = 1;
}

void PauseButtonOnPress() {
 TMR0ON_bit = 0;
}