#line 1 "C:/Users/Public/Documents/Mikroelektronika/Visual GLCD/Projects/AdrianSeeder_Code/mikroC PRO for PIC/AdrianSeeder_events_code.c"
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_objects.h"
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
#line 165 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
void T6963C_init(unsigned int w, unsigned char h, unsigned char fntW);
void T6963C_writeData(unsigned char mydata);
void T6963C_writeCommand(unsigned char mydata);
void T6963C_setPtr(unsigned int addr, unsigned char t);
void T6963C_waitReady(void);
void T6963C_fill(unsigned char mydata, unsigned int start, unsigned int len);
void T6963C_dot(int x, int y, unsigned char color);
void T6963C_write_char(unsigned char c, unsigned char x, unsigned char y, unsigned char mode);
void T6963C_write_text(unsigned char *str, unsigned char x, unsigned char y, unsigned char mode);
void T6963C_line(int px0, int py0, int px1, int py1, unsigned char pcolor);
void T6963C_rectangle(int x0, int y0, int x1, int y1, unsigned char pcolor);
void T6963C_box(int x0, int y0, int x1, int y1, unsigned char pcolor);
void T6963C_circle(int x, int y, long r, unsigned char pcolor);
void T6963C_image(const char *pic);
void T6963C_sprite(unsigned char px, unsigned char py, const char *pic, unsigned char sx, unsigned char sy);
void T6963C_set_cursor(unsigned char x, unsigned char y);
void T6963C_PartialImage(unsigned int x_left, unsigned int y_top, unsigned int width,
 unsigned int height, code const unsigned short * image);
void T6963C_Rectangle_Round_Edges(unsigned int x_upper_left, unsigned int y_upper_left,
 unsigned int x_bottom_right, unsigned int y_bottom_right,
 unsigned int round_radius, unsigned short color);
void T6963C_Rectangle_Round_Edges_Fill(unsigned int x_upper_left, unsigned int y_upper_left,
 unsigned int x_bottom_right, unsigned int y_bottom_right,
 unsigned int round_radius, unsigned short color);
void T6963C_Circle_Fill(int x_center, int y_center, int radius, unsigned short color);
#line 194 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/__t6963c.h"
extern sfr char T6963C_dataPort;
extern sfr char T6963C_cntlPort;

extern unsigned int T6963C_grWidth;
extern unsigned int T6963C_grHeight;
extern unsigned int T6963C_txtCols;

extern unsigned int T6963C_fontWidth;
extern unsigned int T6963C_grHomeAddr;
extern unsigned int T6963C_textHomeAddr;
extern unsigned int T6963C_grMemSize;
extern unsigned int T6963C_txtMemSize;

extern sfr sbit T6963C_cntlwr;
extern sfr sbit T6963C_cntlrd;
extern sfr sbit T6963C_cntlcd;
extern sfr sbit T6963C_cntlrst;

extern unsigned char T6963C_display;
#line 2 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char Visible;
 char Active;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 char Corner_Radius;
 char PressColEnabled;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char *Caption;
 const char *FontName;
 unsigned char Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef const struct CLabel {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 const char *Caption;
 const char *FontName;
 unsigned char Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCLabel;

typedef const struct CBox_Round {
 TScreen* OwnerScreen;
 char Order;
 char Left;
 char Top;
 char Width;
 char Height;
 char Visible;
 char Active;
 char Transparent;
 char Corner_Radius;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCBox_Round;

struct Screen {
 unsigned short ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CLabelsCount;
 TCLabel * const code *CLabels;
 unsigned int CBoxes_RoundCount;
 TCBox_Round * const code *CBoxes_Round;
};

extern TScreen Screen1;
extern TCBox_Round BoxRound1;
extern TCBox_Round BoxRound2;
extern TCLabel Label1;
extern TCLabel Label2;
extern TButton_Round PauseButton;
extern TButton_Round ResetCounterButton;
extern TCLabel Label6;
extern TCLabel Label7;
extern TCLabel Label8;
extern TCLabel Label9;
extern TCLabel Label10;
extern TCLabel Label3;
extern TLabel Km_Box_Text;
extern TLabel acres_box_text;
extern TLabel hectares_box_text;
extern TButton_Round Resume_Button;
extern TButton_Round * const code Screen1_Buttons_Round[3];
extern TLabel * const code Screen1_Labels[3];
extern TCLabel * const code Screen1_CLabels[8];
extern TCBox_Round * const code Screen1_CBoxes_Round[2];





void PauseButtonOnPress();
void ResetCounterButtonOnPress();
void ResumeButtonOnPress();




extern const char BoxRound1_Caption[];
extern const char BoxRound2_Caption[];
extern const char Label1_Caption[];
extern const char Label2_Caption[];
extern char PauseButton_Caption[];
extern char ResetCounterButton_Caption[];
extern const char Label6_Caption[];
extern const char Label7_Caption[];
extern const char Label8_Caption[];
extern const char Label9_Caption[];
extern const char Label10_Caption[];
extern const char Label3_Caption[];
extern char Km_Box_Text_Caption[];
extern char acres_box_text_Caption[];
extern char hectares_box_text_Caption[];
extern char Resume_Button_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawCRoundBox(TCBox_Round *ACround_box);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/documents/mikroelektronika/visual glcd/projects/adrianseeder_code/mikroc pro for pic/adrianseeder_resources.h"
const code char Tahoma16x19_Regular[];
const code char Tahoma19x23_Regular[];
const code char Tahoma10x11_Regular[];
#line 8 "C:/Users/Public/Documents/Mikroelektronika/Visual GLCD/Projects/AdrianSeeder_Code/mikroC PRO for PIC/AdrianSeeder_events_code.c"
extern float acres_covered;
extern float km_traveled ;
extern float hectares_covered;
extern unsigned long current_count;
void update_boxes(void);

extern void calculate_convert(void);

void ClearLabel(TLabel *lbl){
 T6963C_Set_Font_Adv(lbl->Fontname, 0, 0);
 T6963C_Write_Text_Adv(lbl->Caption, lbl->Left, lbl->Top);
}


 void update_boxes(void){
 calculate_convert();

 ClearLabel(&Km_Box_Text);
 sprintf(Km_Box_Text.Caption,"%.3f",km_traveled);
 DrawLabel(&Km_Box_Text);

 ClearLabel(&Acres_Box_Text);
 sprintf(Acres_Box_Text.Caption,"%.3f",acres_covered);
 DrawLabel(&Acres_Box_Text);

 ClearLabel(&Hectares_Box_Text);
 sprintf(Hectares_Box_Text.Caption,"%.3f",hectares_covered);
 DrawLabel(&Hectares_Box_Text);
}






void ResetCounterButtonOnPress() {
current_count = 0;
update_boxes();
}

void ResumeButtonOnPress() {
 TMR0ON_bit = 1;
}

void PauseButtonOnPress() {
 TMR0ON_bit = 0;
}
